osgSim::Impostor Class Reference

`#include <Impostor>`

Inheritance diagram for osgSim::Impostor:

## Public Types

typedef std::vector< osg::ref_ptr< ImpostorSprite > > | ImpostorSpriteList
Public Types inherited from osg::LOD
enum | CenterMode { USE_BOUNDING_SPHERE_CENTER , USER_DEFINED_CENTER , UNION_OF_BOUNDING_SPHERE_AND_USER_DEFINED }
enum | RangeMode { DISTANCE_FROM_EYE_POINT , PIXEL_SIZE_ON_SCREEN }
typedef osg::BoundingSphere::vec_type | vec_type
typedef osg::BoundingSphere::value_type | value_type
typedef std::pair< float, float > | MinMaxPair
typedef std::vector< MinMaxPair > | RangeList
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Impostor ()
| Impostor (const Impostor &es, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Node (osgSim, Impostor)
virtual void | traverse (osg::NodeVisitor &nv)
void | setImpostorThreshold (float distance)
float | getImpostorThreshold () const
void | setImpostorThresholdToBound (float ratio=1.0f)
ImpostorSprite * | findBestImpostorSprite (unsigned int contextID, const osg::Vec3 &currLocalEyePoint) const
void | addImpostorSprite (unsigned int contextID, ImpostorSprite *is)
ImpostorSpriteList & | getImpostorSpriteList (unsigned int contexID)
const ImpostorSpriteList & | getImpostorSpriteList (unsigned int contexID) const
virtual osg::BoundingSphere | computeBound () const
Public Member Functions inherited from osg::LOD
| LOD ()
| LOD (const LOD &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, LOD)
virtual bool | addChild (Node *child)
virtual bool | addChild (Node *child, float rmin, float rmax)
template<class T>
bool | addChild (const ref_ptr< T > &child, float rmin, float rmax)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove=1)
void | setCenterMode (CenterMode mode)
CenterMode | getCenterMode () const
void | setCenter (const vec_type &center)
const vec_type & | getCenter () const
void | setRadius (value_type radius)
value_type | getRadius () const
void | setRangeMode (RangeMode mode)
RangeMode | getRangeMode () const
void | setRange (unsigned int childNo, float min, float max)
float | getMinRange (unsigned int childNo) const
float | getMaxRange (unsigned int childNo) const
unsigned int | getNumRanges () const
void | setRangeList (const RangeList &rangeList)
const RangeList & | getRangeList () const
template<class T>
bool | addChild (const ref_ptr< T > &child)
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Impostor ()
ImpostorSprite * | createImpostorSprite (osgUtil::CullVisitor *cv)
Protected Member Functions inherited from osg::LOD
virtual | ~LOD ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::buffered_object< ImpostorSpriteList > | _impostorSpriteListBuffer
float | _impostorThreshold
Protected Attributes inherited from osg::LOD
CenterMode | _centerMode
vec_type | _userDefinedCenter
value_type | _radius
RangeMode | _rangeMode
RangeList | _rangeList
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

Impostor - is a form of Level Of Detail group node which allows both switching between children depending on distance from eye point and image caching.

The principle behind Imposters is that they cache an image of real geometry and then the image is drawn in subsequent frames instead of the real geometry. It's a bit like a Billboard but is updated at runtime and w.r.t view point. By drawing just the texture mapped quad you can cut down scene complexity and improve performance.

For more details have a look at:

http://grail.cs.washington.edu/projects/hic/

The OSG doesn't implement exactly the same technique as above, but its should be a good starting place. The OSG's impostors are much less intrusive since you don't need to restructure your whole scene to use them.

All you need to do to use Impostors is to set up the visible range values for each LOD child of the Impostor, as per osg::LOD, and set an Impostor threshold to tell the renderer at what distance the Impostor's image caching should cut in. The osg::CullVisitor automatically handles all the setting of pre-rendering stages to calculate the required ImpostorSprites (which encapsulates the image cache and quad), and updates them as the view point changes. If you use osg::SceneView/CullVisitor all the complexity of supporting Impostor will be nicely hidden away.

TODO: Various improvements are planned for the Impostor- 1) Estimation of how many frames an ImpostorSprite will be reused, if it won't be used more often than a minimum threshold then do not create ImpostorSprite - use the real geometry. 2) Sharing of texture memory between ImpostorSprites. 3) Simple 3D geometry for ImpostorSprite's rather than Billboarding. 4) Shrinking of the ImpostorSprite size to more closely fit the underlying geometry.

## Member Typedef Documentation

## ImpostorSpriteList

typedef std::vector< osg::ref_ptr<ImpostorSprite> > osgSim::Impostor::ImpostorSpriteList

## Constructor & Destructor Documentation

## Impostor() [1/2]

osgSim::Impostor::Impostor | ( |  | ) |

Referenced by Impostor(), and META_Node().

## Impostor() [2/2]

osgSim::Impostor::Impostor | ( | const Impostor & | es,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

inline

References _impostorThreshold, Impostor(), osg::LOD::LOD(), and osg::CopyOp::SHALLOW_COPY.

## ~Impostor()

virtual osgSim::Impostor::~Impostor | ( |  | ) |

inline protected virtual

## Member Function Documentation

## addImpostorSprite()

void osgSim::Impostor::addImpostorSprite | ( | unsigned int | contextID,
|  | ImpostorSprite * | is )

Add an ImpostorSprite to the Impostor.

## computeBound()

virtual osg::BoundingSphere osgSim::Impostor::computeBound | ( |  | ) | const

virtual

Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound().

Reimplemented from osg::LOD.

## createImpostorSprite()

ImpostorSprite * osgSim::Impostor::createImpostorSprite | ( | osgUtil::CullVisitor * | cv | ) |

protected

## findBestImpostorSprite()

ImpostorSprite * osgSim::Impostor::findBestImpostorSprite | ( | unsigned int | contextID,
|  | const osg::Vec3 & | currLocalEyePoint ) const

Find the ImposterSprite which fits the current eye point best.

## getImpostorSpriteList() [1/2]

ImpostorSpriteList & osgSim::Impostor::getImpostorSpriteList | ( | unsigned int | contexID | ) |

inline

Get the list of ImpostorSprites attached to this Impostor.

References _impostorSpriteListBuffer.

## getImpostorSpriteList() [2/2]

const ImpostorSpriteList & osgSim::Impostor::getImpostorSpriteList | ( | unsigned int | contexID | ) | const

inline

Get a const list of ImpostorSprites attached to this const Impostor.

References _impostorSpriteListBuffer.

## getImpostorThreshold()

float osgSim::Impostor::getImpostorThreshold | ( |  | ) | const

inline

References _impostorThreshold.

## META_Node()

osgSim::Impostor::META_Node | ( | osgSim | ,
|  | Impostor | )

References Impostor().

## setImpostorThreshold()

void osgSim::Impostor::setImpostorThreshold | ( | float | distance | ) |

inline

Set the Impostor threshold distance. For eye points further than this threshold the Imposter is used if appropriate, otherwise the LOD children as chosen as per a standard LOD node.

References _impostorThreshold.

## setImpostorThresholdToBound()

void osgSim::Impostor::setImpostorThresholdToBound | ( | float | ratio = 1.0f | ) |

inline

Set the Impostor threshold distance relative to the node's bounding sphere's radius.

References _impostorThreshold, and osg::Node::getBound().

## traverse()

virtual void osgSim::Impostor::traverse | ( | osg::NodeVisitor & |  | ) |

virtual

Traverse downwards : calls children's accept method with NodeVisitor.

Reimplemented from osg::LOD.

## Member Data Documentation

## _impostorSpriteListBuffer

osg::buffered_object<ImpostorSpriteList> osgSim::Impostor::_impostorSpriteListBuffer

mutable protected

Referenced by getImpostorSpriteList(), and getImpostorSpriteList().

## _impostorThreshold

float osgSim::Impostor::_impostorThreshold

protected

Referenced by getImpostorThreshold(), Impostor(), setImpostorThreshold(), and setImpostorThresholdToBound().

The documentation for this class was generated from the following file:

- Impostor